﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.9
@EndOfDesignText@
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"

Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore	
	Public SQL1 As SQL	
	Private bxtTable As B4XTable
	Private ToastMessage As BCToast
	Private rp As RuntimePermissions
	Private DBFilePath As String
	
End Sub

'You can add more parameters here.
Public Sub Initialize	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	
	If rp.Check(rp.PERMISSION_READ_EXTERNAL_STORAGE) = False Then
		rp.CheckAndRequest(rp.PERMISSION_WRITE_EXTERNAL_STORAGE)
		wait for B4XPage_PermissionResult(Permision As String, Result As Boolean)
		If Result = False Then
			MsgboxAsync("No permission to access external storage", "")
			Return
		Else
			Log("Permission granted")
		End If
	End If
	
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("Main")
	
	#If B4J
	xui.SetDataFolder("B4XPages_SQLiteLight2")
	#End If
	
	DBFilePath=File.DirRootExternal	
	If File.Exists(File.DirRootExternal, "persons.db") = False Then
		File.Copy(File.DirAssets, "persons.db", DBFilePath, "persons.db")
	End If
	#If B4J
	SQL1.InitializeSQLite(xui.DefaultFolder, "persons.db", True)
	#Else
	SQL1.Initialize(DBFilePath, "persons.db", True)
	#End If
	
	ToastMessage.Initialize(Root)
	
	InitTable
End Sub

Private Sub B4XPage_Appear
	If rp.Check(rp.PERMISSION_READ_EXTERNAL_STORAGE) = True Then ShowTable	
End Sub

'Shows the database in a table in a B4XTable
Public Sub ShowTable
	Private Query As String
	
	Query = "SELECT FirstName, LastName, City FROM persons"
	Dim Data As List
	Data.Initialize
	Dim rs As ResultSet = SQL1.ExecQuery(Query)
	Do While rs.NextRow
		Dim row(3) As Object
		row(0) = rs.GetString("FirstName")
		row(1) = rs.GetString("LastName")
		row(2) = rs.GetString("City")
		Data.Add(row)
	Loop
	rs.Close
	bxtTable.SetData(Data)	
End Sub

Private Sub InitTable
	bxtTable.AddColumn("First name", bxtTable.COLUMN_TYPE_TEXT)
	bxtTable.AddColumn("Last name", bxtTable.COLUMN_TYPE_TEXT)
	bxtTable.AddColumn("City", bxtTable.COLUMN_TYPE_TEXT)
End Sub

Private Sub B4XPage_CloseRequest As ResumableSub
	Dim sf As Object = xui.Msgbox2Async("Do you want to quit ?", "Quit", "Yes", "Cancel", "No", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		SQL1.Close
		Return True
	End If
	Return False
End Sub